﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

void bfs(int n, vector<vector<int>> g, int cnt, set<int>& res, vector<bool>& used) {
	res.insert(n);
	if (cnt == 0) {
		return;
	}

	for (int el : g[n]) {
		if (!used[el]) {
			res.insert(el);
			used[el] = true;
			bfs(el, g, cnt - 1, res, used);
		}
	}
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> g(n + 1);

	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;

		g[a].push_back(b);
		g[b].push_back(a);
	}

	set<int> res;
	vector<bool> used(n + 1);
	for (int i = 0; i < k; i++) {
		//for (auto el : res) {
		//	cout << el << " ";
		//}
		//cout << endl << "-----------" << endl;

		int p, h;
		cin >> p >> h;

		//for (int el : g[p]) {
		//	cout << el << " ";
		//}
		//cout << endl;

		bfs(p, g, h, res, used);
	}

	if (res.empty()) {
		cout << "";
	}
	else {
		cout << res.size() << endl;
		for (int el : res) {
			cout << el << " ";
		}
	}

	return 0;
}
