﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

set<int> res;

set<int> bfs(int n, vector<vector<int>> g, int cnt, set<int> res, vector<bool>& used) {
	res.insert(n);
	if (cnt == 0) {
		return res;
	}

	for (int el : g[n]) {
		if (!used[el]) {
			res.insert(el);
			used[el] = true;
			res = bfs(el, g, cnt - 1, res, used);
		}
	}

	return res;
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> g(n + 1);

	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;

		g[a].push_back(b);
		g[b].push_back(a);
	}

	vector<bool> used(n + 1);
	bool ok = true;

	for (int i = 0; i < k; i++) {
		int p, h;
		cin >> p >> h;

		if (!ok) continue;

		int cnt = 0;
		for (bool u : used) {
			if (u) cnt++;
		}

		if (cnt == n) {
			ok = false;
			continue;
		}

		res = bfs(p, g, h, res, used);
	}
	
	int cnt = 0;

	if (res.empty()) {
		cout << "";
	}
	else {
		cout << res.size() << endl;
		for (int el : res) {
			cout << el << " ";
		}
	}

	return 0;
}
